cad9e1cac53e1e60b144e3d257f658b89ce72443
[distro-setup] / mount-latest-subvol
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 this_file="$(readlink -f -- "${BASH_SOURCE[0]}")"
17 readonly this_file
18 cd /
19 [[ $EUID == 0 ]] || exec sudo -E "$this_file" "$@"
20
21 source /usr/local/lib/err
22
23 usage() {
24 cat <<EOF
25 Usage: ${0##*/} [OPTIONS] [SUBVOLUMES]
26
27 -h|--help Print help and exit.
28 -f|--force Use kill -9 to try fixing unmount errors
29 -v|--verbose Be more verbose
30
31
32 Note: In git this is not not executable because it's meant to be installed
33 using ./install-my-scripts
34
35 Note: Uses util-linux getopt option parsing: spaces between args and
36 options, short options can be combined, options before args.
37 EOF
38 exit $1
39 }
40
41 pre="mount-latest-subvol:${SSH_CLIENT:+ $HOSTNAME:}"
42
43 tu() {
44 while read -r line; do
45 file="$1"
46 grep -xFq "$line" "$file" || tee -a "$file"<<<"$line"
47 done
48 }
49 d() {
50 if $verbose; then
51 printf "$pre %s\n" "$*"
52 fi
53 }
54 m() {
55 if $verbose; then
56 printf "$pre %s\n" "$*"
57 fi
58 "$@"
59 }
60 x() {
61 printf "$pre %s\n" "$*"
62 "$@"
63 }
64
65 mnt() {
66 dir=$1
67 if ! mountpoint -q $dir; then
68 mkdir -p $dir
69 m mount $dir
70 fi
71 }
72 fstab() {
73 while read -r start mpoint end; do
74 l="$start $mpoint $end"
75 # kill off any lines that duplicate the mount point.
76 sed --follow-symlinks -ri "\%$l%b;\%^\s*\S+\s+$mpoint\s%d" /etc/fstab
77 tu /etc/fstab <<<"$l"
78 done
79 }
80 pid-check() {
81 for p in ${pids}; do
82 for m in ${my_pids[@]}; do
83 if (( p == m )); then
84 echo "$0: error: pids to kill includes our pid or a parent. ps output:" >&2
85 ps -f -p $p
86 exit 1
87 fi
88 done
89 done
90 }
91 kill-dir() {
92 for sig; do
93 echo kill-dir $sig
94 found_pids=false
95 if pids=$(timeout 4 lsof -t $dir); then
96 found_pids=true
97 timeout 4 lsof -w $dir
98 pid-check
99 kill -$sig $pids
100 fi
101 # fuser will find open sockets that lsof won't, for example from gpg-agent.
102 # note: -v shows kernel processes, which then doesn't return true when we want
103 if pids=$(timeout 4 fuser -m $dir 2>/dev/null); then
104 pid-check
105 found_pids=true
106 fuser -$sig -mvk $dir
107 fi
108 sleep .5
109 if ! $found_pids; then
110 return 0
111 fi
112 done
113 return 1
114 }
115 umount-kill() {
116 dir=$1
117 if mountpoint -q $dir; then
118 if m umount -R $dir; then
119 unmounted+=($dir)
120 else
121 if ! kill-dir TERM TERM TERM INT INT HUP HUP TERM TERM TERM INT INT HUP HUP; then
122 if $force; then kill-dir KILL; fi
123 fi
124
125 if m umount -R $dir; then
126 unmounted+=($dir)
127 else
128 echo "$0: failed to umount $dir"
129 umount_ret=false
130 ret=1
131 fi
132 fi
133 fi
134 }
135
136 # duplicated in check-subvol
137 # Reassign $1 var from /dev/dm- to corresponding /dev/mapper/
138 mapper-dev() {
139 local mapdev
140 local -n devref=$1
141 if [[ $devref == /dev/dm-* ]]; then
142 for mapdev in /dev/mapper/*; do
143 if [[ $(readlink -f $mapdev) == "$devref" ]]; then
144 devref=$mapdev
145 break
146 fi
147 done
148 fi
149 }
150
151
152 ##### begin command line parsing ########
153
154 # you can remove this if you do not have options which can have args with spaces or empty.
155
156 verbose=true
157 force=false
158 temp=$(getopt -l help,force,verbose hfv "$@") || usage 1
159 eval set -- "$temp"
160 while true; do
161 case $1 in
162 -f|--force) force=true ;;
163 -v|--verbose) verbose=true ;;
164 -h|--help) usage ;;
165 --) shift; break ;;
166 *) echo "$0: unexpected args: $*" >&2 ; usage 1 ;;
167 esac
168 shift
169 done
170
171 if (( $# )); then
172 all_vols=( "$@" )
173 else
174 all_vols=(q a o i ar qd qr)
175 fi
176
177 ##### end command line parsing ########
178
179 ret=0
180
181 ##### begin setup fstab for subvols we care about ######
182
183 if [[ -e /mnt/root/root2-crypttab ]]; then
184 tu /etc/crypttab </mnt/root/root2-crypttab
185 while read -r mapper_dev _; do
186 if [[ ! -e /dev/mapper/$mapper_dev ]]; then
187 m cryptdisks_start $mapper_dev
188 fi
189 done < <(cat /mnt/root/root2-crypttab)
190 fi
191 if [[ -e /mnt/root/root2-fstab ]]; then
192 tu /etc/fstab </mnt/root/root2-fstab
193 mnt /mnt/root2
194 mnt /mnt/boot2
195 fi
196
197 root_dev=$(awk '$2 == "/" {print $1}' /etc/mtab)
198 mapper-dev root_dev
199 o_dev=$(awk '$2 == "/mnt/o" {print $1}' /etc/mtab)
200 mapper-dev o_dev
201
202
203 # root2_dev=$(awk '$2 == "/mnt/root2" {print $1}' /etc/mtab)
204 # mapper-dev root2_dev
205 # # dont bother with the above for crypt2_dev
206 # crypt2_dev=$root2_dev
207
208
209 if cryptsetup status $root_dev &>/dev/null; then
210 crypt_dev=$root_dev
211 else # if we are in a recovery boot, find the next best crypt device
212 mopts=,noauto
213 # todo: I think I had an idea to not setup /o in this case,
214 # but never finished implementing it
215 for dev in $(dmsetup ls --target crypt | awk '{print $1}'); do
216 dev=/dev/mapper/$dev
217 if awk '{print $1}' /etc/mtab | grep -Fx $dev &>/dev/null; then
218 crypt_dev=$dev
219 break
220 fi
221 done
222 fi
223
224
225
226 # dont tax the cpus of old laptops
227 if (( $(nproc) > 2)); then
228 mopts+=,compress=zstd
229 fi
230
231 fstab <<EOF
232 $crypt_dev /a btrfs noatime,subvol=a$mopts 0 0
233 EOF
234
235 shopt -s nullglob
236
237 # ssh and probably some other things care about parent directory
238 # ownership, and ssh doesn\'t allow any group writable parent
239 # directories, so we are forced to use a directory structure similar
240 # to home directories
241 fa=(/mnt/root/btrbk/q.*); f=${fa[0]}
242 if [[ -e $f ]]; then
243 fstab <<EOF
244 $crypt_dev /q btrfs noatime,subvol=q,gid=1000$mopts 0 0
245 $crypt_dev /qd btrfs noatime,subvol=qd,gid=1000$mopts 0 0
246 /q/p /p none bind$mopts 0 0
247 EOF
248 fi
249
250 fa=(/mnt/root/btrbk/qr.*); f=${fa[0]}
251 if [[ -e $f ]]; then
252 fstab <<EOF
253 $crypt_dev /qr btrfs noatime,subvol=qr$mopts 0 0
254 EOF
255 fi
256
257 fa=(/mnt/root/btrbk/ar.*); f=${fa[0]}
258 if [[ -e $f ]]; then
259 fstab <<EOF
260 $crypt_dev /ar btrfs noatime,subvol=ar,uid=1000,gid=1000$mopts 0 0
261 EOF
262 fi
263
264
265 fa=(/mnt/o/btrbk/o.*); f=${fa[0]}
266 if [[ -e $f ]]; then
267 if [[ $o_dev != "$root_dev" ]]; then
268 fstab <<EOF
269 $o_dev /o btrfs noatime,subvol=o$mopts 0 0
270 EOF
271 fi
272 fstab <<EOF
273 /o/m /m none bind$mopts 0 0
274 /o/debbugs /debbugs none bind$mopts 0 0
275 EOF
276 fi
277
278
279 ##### end setup fstab for subvols we care about ######
280
281 ### begin get pids that this program depends on so we dont kill them
282 my_pids=($$ $PPID)
283 loop_limit=30
284 count=0
285 while [[ ${my_pids[-1]} != 1 && ${my_pids[-1]} != "${my_pids[-2]}" && $count -lt $loop_limit ]]; do
286 count=$((count + 1))
287 p=$(ps -p ${my_pids[-1]} -o ppid=)
288 if [[ $p == 0 || ! $p ]]; then
289 break
290 fi
291 my_pids+=($p)
292 done
293 ### end get pids that this program depends on so we dont kill them
294
295 for vol in ${all_vols[@]}; do
296 d=/$vol
297 if ! awk '$3 == "btrfs" {print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
298 continue
299 fi
300
301
302 ##### begin building up list of bind mounts ######
303 binds=() # list of bind mounts
304 roots=($d)
305 while true; do
306 new_roots=()
307 for r in ${roots[@]}; do
308 # eg. when r=/q/p, for lines like
309 # /q/p /p none bind 0 0
310 # output /p
311 new_roots+=("$(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+(\S+,|)bind[[:space:],].*#\1#p" /etc/fstab)")
312 done
313 (( ${#new_roots} )) || break
314 binds+=(${new_roots[@]})
315 # roots is used to recursively find binds of binds if they exist.
316 roots=( ${new_roots[@]} )
317 done
318 ##### end building up list of bind mounts ######
319
320
321
322 # if latest is already mounted, make sure binds are mounted and move on
323 m check-subvol-stale $d
324 # populated by check-subvol-stale if stale
325 if ! fresh_snap=$(cat /nocow/btrfs-stale/$vol 2>/dev/null); then
326 mnt $d
327 did=$(stat -c%d $d)
328 for b in ${binds[@]}; do
329 if mountpoint -q $b; then
330 bid=$(stat -c%d $b)
331 if [[ $did != "$bid" ]]; then
332 umount-kill $b
333 fi
334 fi
335 mnt $b
336 done
337 continue
338 fi
339
340
341 ##### begin checking for loopback mounts ####
342 found_loop=false
343 for l in $(losetup -ln|awk '{print $6}'); do
344 for dir in $d ${binds[@]}; do
345 if [[ $l == $dir* ]]; then
346 echo "$0: found loopback mount $l. giving up on unmounting $dir"
347 ret=1
348 found_loop=true
349 break
350 fi
351 done
352 if $found_loop; then
353 break
354 fi
355 done
356 if $found_loop; then
357 continue
358 fi
359 ##### end end checking loopback mounts ####
360
361
362 ## not using arbtt at the moment
363 # if [[ $vol == q ]]; then
364 # ## allow to fail, user might not be logged in
365 # x sudo -u $(id -nu 1000) XDG_RUNTIME_DIR=/run/user/1000 systemctl --user stop arbtt ||:
366 # fi
367 umount_ret=true
368 unmounted=()
369 for dir in $(echo $d ${binds[*]}\ |tac -s\ ); do
370 umount-kill $dir
371 done
372
373 # if we unmounted some but not all, restore them and move on
374 if ! $umount_ret; then
375 for dir in ${unmounted[@]}; do
376 mnt $dir
377 done
378 continue
379 fi
380
381 #### begin dealing with leaf vols ####
382
383 ### begin getting root_dir
384 ### this is duplicated in check-subvol-stale
385
386 dev=$(sed -rn "s,^\s*([^#]\S*)\s+$d\s.*,\1,p" /etc/fstab /etc/mtab|head -n1)
387 d dev=$dev
388 # note, we need $dev because $d might not be mounted, and we do this loop
389 # because the device in fstab for the rootfs can be different.
390 for devx in $(btrfs fil show $dev| sed -rn 's#.*path (\S+)$#\1#p'); do
391 if [[ $devx == dm-* ]]; then
392 devx=/dev/$devx
393 mapper-dev devx
394 fi
395 d devx=$devx
396 root_dir=$(sed -rn "s,^\s*$devx\s+(\S+).*\bsubvolid=[05]\b.*,\1,p" /etc/mtab /etc/fstab|head -n1)
397 if [[ $root_dir ]]; then
398 d root_dir=$root_dir
399 break
400 fi
401 done
402 if [[ ! $root_dir ]]; then
403 echo "$0: error could not find root subvol mount for $dev" >&2
404 exit 1
405 fi
406 ### end getting root_dir
407
408 cd $root_dir
409 if [[ -e $vol ]]; then
410 if [[ $vol == qd ]]; then
411 m btrfs sub del qd
412 else
413 leaf=$vol.leaf.$(date +%Y-%m-%dT%H:%M:%S%z)
414 m mv $vol $leaf
415 m btrfs property set -ts $leaf ro true
416
417 ### begin check if leaf is different, delete it if not ###
418 parentid=$(btrfs sub show $leaf | awk '$1 == "Parent" && $2 == "UUID:" {print $3}')
419 bsubs=(btrbk/$vol.*)
420 bsub= # base subvolume
421 # go in reverse order as its more likely to be at the end
422 for ((i=${#bsubs[@]}-1; i>=0; i--)); do
423 if [[ $parentid == $(btrfs sub show ${bsubs[i]} | awk '$1 == "UUID:" {print $2}') ]]; then
424 bsub=${bsubs[i]}
425 break
426 fi
427 done
428 if [[ $bsub ]]; then
429 # in testing, same subvol is 136 bytes. allow some overhead. 32 happens sometimes under systemd.
430 # $ errno 32
431 # EPIPE 32 Broken pipe
432 lines=$(btrfs send --no-data -p $bsub $leaf | btrfs receive --dump | head -n 100 | wc -l || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]])
433 if [[ $lines == 0 ]]; then
434 # example output of no differences:
435 # snapshot ./qrtest uuid=c41ff6b7-0527-f34d-95ac-190eecf54ff5 transid=2239 parent_uuid=64949e1b-4a3e-3945-9a8e-cd7b7c15d7d6 parent_transid=2239
436 echo suspected identical: $bsub $leaf
437 x btrfs sub del $leaf
438 fi
439 fi
440 ### end check if leaf is different, delete it if not ###
441
442 ## begin expire leaf vols ##
443 leaf_vols=($vol.leaf.*)
444 count=${#leaf_vols[@]}
445 leaf_limit_time=$(( EPOCHSECONDS - 60*60*24*60 )) # 60 days
446 leaf_new_limit_time=$(( EPOCHSECONDS - 60*60*24 * 5 )) # 5 days this
447 # goes backwards from oldest. leaf_new_limit_time is a safety
448 # measure to ensure we don't delete very recent leafs.
449 for leaf in ${leaf_vols[@]}; do
450 leaf_time=$(date -d ${leaf#"$vol".leaf.} +%s)
451 if (( leaf_limit_time > leaf_time || ( leaf_new_limit_time > leaf_time && count > 30 ) )); then
452 x btrfs sub del $leaf
453 fi
454 count=$((count-1))
455 done
456 fi
457 ## end expire leaf vols ##
458 fi
459 #### end dealing with leaf vols ####
460
461 # Note, we make a few assumptions in this script, like
462 # $d was not a different subvol id than $vol, and
463 # things otherwise didn't get mounted very strangely.
464 m btrfs sub snapshot $fresh_snap $vol
465 for dir in $d ${binds[@]}; do
466 m mnt $dir
467 done
468
469 ## arbtt disabled for now
470 # if [[ $vol == q ]]; then
471 # # maybe this will fail if X is not running
472 # x sudo -u $(id -nu 1000) XDG_RUNTIME_DIR=/run/user/1000 systemctl --user start arbtt ||:
473 # fi
474
475 stale_dir=/nocow/btrfs-stale
476 rm -f $stale_dir/$d
477 done
478
479
480
481 for dir in /mnt/r7/amy/{root/root,boot/boot}_ubuntubionic /mnt/{root2/root,boot2/boot}_ubuntubionic; do
482 vol=${dir##*/}
483 root_dir=${dir%/*}
484 if [[ ! -d $root_dir ]]; then
485 # this only exists on host kd currently
486 continue
487 fi
488 # if latest is already mounted, make sure binds are mounted and move on
489 m check-subvol-stale -p $dir
490 # populated by check-subvol-stale if stale
491 if ! fresh_snap=$(cat /nocow/btrfs-stale/$vol 2>/dev/null); then
492 continue
493 fi
494 if [[ -d $dir ]]; then
495 if ! kill-dir TERM TERM TERM INT INT HUP HUP TERM TERM TERM INT INT HUP HUP; then
496 if $force; then kill-dir KILL; fi
497 fi
498 m btrfs sub del $dir
499 fi
500 m btrfs sub snapshot $fresh_snap $dir
501 rm -f /nocow/btrfs-stale/$vol
502 done
503
504 if (( ret >= 1 )); then
505 echo "$0: exit status $ret. see error above"
506 fi
507 exit $ret
508
509